'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _runEventHandlerOnce = require('run-event-handler-once');

var _runEventHandlerOnce2 = _interopRequireDefault(_runEventHandlerOnce);

var _focusTrap = require('./helpers/focusTrap');

var _focusTrap2 = _interopRequireDefault(_focusTrap);

var _focusManager = require('./helpers/focusManager');

var _styles = require('./helpers/styles');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TAB_KEY = 9;
var ESC_KEY = 27;
var EVENT_LISTENER_OPTIONS = {
  add: { capture: false },
  remove: { capture: false }
};

var OffCanvas = function (_Component) {
  _inherits(OffCanvas, _Component);

  function OffCanvas() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, OffCanvas);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = OffCanvas.__proto__ || Object.getPrototypeOf(OffCanvas)).call.apply(_ref, [this].concat(args))), _this), _this.open = function () {
      var returnFocusAfterClose = _this.props.returnFocusAfterClose;


      (0, _styles.shouldShowContent)(_this.content, true);

      if (returnFocusAfterClose) {
        (0, _focusManager.focusLater)();
      }

      (0, _runEventHandlerOnce2.default)(_this.content, 'transitionend', function () {
        _this.setInitialFocus();
      }, EVENT_LISTENER_OPTIONS);

      (0, _styles.shouldHideHorizontalScrollbar)(true);
    }, _this.close = function () {
      var _this$props = _this.props,
          mainContainerSelector = _this$props.mainContainerSelector,
          returnFocusAfterClose = _this$props.returnFocusAfterClose;


      if (returnFocusAfterClose) {
        if (mainContainerSelector) {
          (0, _runEventHandlerOnce2.default)(_this.mainContainer, 'transitionend', function () {
            // If the Open button is off the screen, returning focus
            // immediately breaks the transition. Transitionend event ensures
            // that the animation has enough time to finish.
            (0, _focusManager.returnFocus)();
            (0, _styles.shouldShowContent)(_this.content, false);
            (0, _styles.shouldHideHorizontalScrollbar)(false);
          }, EVENT_LISTENER_OPTIONS);
        } else {
          (0, _runEventHandlerOnce2.default)(_this.content, 'transitionend', function () {
            (0, _focusManager.returnFocus)();
            (0, _styles.shouldShowContent)(_this.content, false);
          }, EVENT_LISTENER_OPTIONS);
        }
      }
    }, _this.setInitialFocus = function () {
      var _this$props2 = _this.props,
          focusFirstChildAfterOpen = _this$props2.focusFirstChildAfterOpen,
          focusThisChildAfterOpen = _this$props2.focusThisChildAfterOpen;


      if (focusFirstChildAfterOpen) {
        (0, _focusManager.focusFirstChild)(_this.content);
      } else if (focusThisChildAfterOpen) {
        (0, _focusManager.focusChild)(_this.content, focusThisChildAfterOpen);
      } else {
        _this.focusContent();
      }
    }, _this.parentHandlesClose = function (event) {
      if (_this.props.onClose) {
        _this.props.onClose(event);
      }
    }, _this.handleOverlayClick = function (event) {
      if (_this.props.closeOnOverlayClick && event.target === _this.overlay) {
        _this.parentHandlesClose(event);
      }
    }, _this.handleKeyDown = function (event) {
      if (_this.props.trapFocusAfterOpen) {
        if (event.keyCode === TAB_KEY) {
          (0, _focusTrap2.default)(event, _this.content);
        }
      }

      if (_this.props.closeOnEsc && event.keyCode === ESC_KEY) {
        _this.parentHandlesClose(event);
      }
    }, _this.setOverlayRef = function (overlay) {
      _this.overlay = overlay;
    }, _this.setContentRef = function (content) {
      _this.content = content;
    }, _this.focusContent = function () {
      return _this.content && _this.content.focus();
    }, _this.buildStyles = function () {
      var _this$props3 = _this.props,
          isOpen = _this$props3.isOpen,
          width = _this$props3.width,
          height = _this$props3.height,
          position = _this$props3.position,
          mainContainerSelector = _this$props3.mainContainerSelector,
          style = _this$props3.style,
          className = _this$props3.className,
          overlayClassName = _this$props3.overlayClassName;


      var extra = {
        container: OffCanvas.extraStyles.container,
        // Remove the extra styles when classNames are passed
        overlay: overlayClassName ? {} : OffCanvas.extraStyles.overlay,
        content: className ? {} : OffCanvas.extraStyles.content
      };

      var main = (0, _styles.createStyles)(OffCanvas.defaultStyles, extra, isOpen, width, height, position, style);

      var applyPushStyles = mainContainerSelector ? (0, _styles.createPushStyles)(OffCanvas.extraStyles.container, isOpen, width, height, position) : null;

      return { main: main, applyPushStyles: applyPushStyles };
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(OffCanvas, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          isOpen = _props.isOpen,
          width = _props.width,
          height = _props.height,
          position = _props.position,
          mainContainerSelector = _props.mainContainerSelector;


      (0, _styles.shouldShowContent)(this.content, isOpen);

      if (mainContainerSelector) {
        // Get the element that should be pushed
        this.mainContainer = document.querySelector(mainContainerSelector);

        // Remove the extra styles when the main container has a className
        if ((0, _styles.hasClassName)(this.mainContainer)) {
          OffCanvas.extraStyles.container = {};
        }
      }

      if (isOpen) {
        this.setInitialFocus();
        if (mainContainerSelector) {
          // If the initial state is set to true, this is the right time to apply
          // some of the push styles to the main container.
          (0, _styles.applyInitialPushStyles)(this.mainContainer, width, height, position);
          (0, _styles.shouldHideHorizontalScrollbar)(true);
        }
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      if (this.props.isOpen && !prevProps.isOpen) {
        this.open();
      } else if (!this.props.isOpen && prevProps.isOpen) {
        this.close();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          isOpen = _props2.isOpen,
          role = _props2.role,
          label = _props2.label,
          labelledby = _props2.labelledby,
          className = _props2.className,
          overlayClassName = _props2.overlayClassName;


      var styles = this.buildStyles();

      if (styles.applyPushStyles) {
        styles.applyPushStyles(this.mainContainer);
      }

      return _react2.default.createElement(
        'div',
        {
          ref: this.setOverlayRef,
          style: styles.main.overlay,
          className: overlayClassName,
          onClick: this.handleOverlayClick,
          'data-testid': 'overlay'
        },
        _react2.default.createElement(
          'div',
          {
            ref: this.setContentRef,
            style: styles.main.content,
            className: className,
            onKeyDown: this.handleKeyDown,
            role: role,
            'aria-label': label,
            'aria-labelledby': labelledby,
            'aria-hidden': !isOpen,
            tabIndex: '-1',
            'data-testid': 'content'
          },
          this.props.children
        )
      );
    }
  }]);

  return OffCanvas;
}(_react.Component);

OffCanvas.defaultProps = {
  isOpen: false,
  width: '300px',
  height: '300px',
  position: 'left',
  closeOnEsc: true,
  closeOnOverlayClick: true,
  trapFocusAfterOpen: true,
  returnFocusAfterClose: true,
  style: {
    overlay: {},
    content: {}
  }
};
OffCanvas.propTypes = {
  isOpen: _propTypes2.default.bool.isRequired,
  width: _propTypes2.default.string,
  height: _propTypes2.default.string,
  position: _propTypes2.default.oneOf(['left', 'right', 'top', 'bottom']),
  mainContainerSelector: _propTypes2.default.string,
  onClose: _propTypes2.default.func,
  closeOnEsc: _propTypes2.default.bool,
  closeOnOverlayClick: _propTypes2.default.bool,
  trapFocusAfterOpen: _propTypes2.default.bool,
  returnFocusAfterClose: _propTypes2.default.bool,
  focusFirstChildAfterOpen: _propTypes2.default.bool,
  focusThisChildAfterOpen: _propTypes2.default.string,
  style: _propTypes2.default.shape({
    container: _propTypes2.default.object,
    overlay: _propTypes2.default.object,
    content: _propTypes2.default.object
  }),
  className: _propTypes2.default.string,
  overlayClassName: _propTypes2.default.string,
  role: _propTypes2.default.string,
  label: _propTypes2.default.string,
  labelledby: _propTypes2.default.string,
  children: _propTypes2.default.node
};
OffCanvas.defaultStyles = {
  overlay: {
    position: 'fixed',
    top: 0,
    left: 0,
    width: '100%',
    height: '100%',
    zIndex: '900'
  },
  content: {
    position: 'fixed',
    zIndex: '1000',
    outline: 0
  }
};
OffCanvas.extraStyles = {
  container: {
    transition: 'transform 0.25s ease-out'
  },
  overlay: {
    background: 'rgba(255, 255, 255, 0.5)'
  },
  content: {
    background: 'rgba(0, 0, 0, 0.1)',
    transition: 'transform 0.25s ease-out'
  }
};
exports.default = OffCanvas;